﻿using UnityEngine;
using System.Collections;

// note that I need to include "using System" -- this is because I use a "string" variable below
using System;



public class spheresound : MonoBehaviour {
	// RTcmix/audio stuff
	private int objno = 0;
	private rtcmixmain RTcmix;

	// the "squish" variable will be used to change the timbre of each STRUM2 note
	int squish;


	// Use this for initialization
	void Start () {
		RTcmix = GameObject.Find ("RTcmixmain").GetComponent<rtcmixmain> ();
		RTcmix.initRTcmix (objno);

		// initial value
		squish = 5;
		RTcmix.SendScore ("MAXBANG(0.1)", objno); // this is to allow RTcmix to get initialized
	}


	// Update is called once per frame
	void Update () {
		if (Input.GetKeyDown (KeyCode.UpArrow)) {
			transform.Translate (0.0f, 0.1f, 0.0f);
			// decrease squish as the sphere gets higher -- brighter amp with lower squish
			squish = squish - 1;
		}
		if (Input.GetKeyDown (KeyCode.DownArrow)) {
			transform.Translate (0.0f, -0.1f, 0.0f);
			// increase squish as the sphere gets lower -- duller amp with higher squish
			squish = squish + 1;
		}
	}


	void OnAudioFilterRead(float[] data, int channels) {
		RTcmix.runRTcmix (data, objno, 0);

		// send a new note whenever there is a bang (and send a future bang message!)
		if (RTcmix.checkbangRTcmix (objno) == 1) {
			// note how the 'squish' variable is isolated when constructing the score string
			string score = "STRUM2(0, 2.5, 20000, 7.00, " +
				squish +
				", 2.5, 0.5) MAXBANG(0.2)"; 

			// and just send the string, now containing the embedded 'squish' value
			RTcmix.SendScore (score, objno);
		}
	}


	void OnApplicationQuit() {
		RTcmix.destroy (objno);
	}
}
